package hornetq.client;

import java.util.HashMap;
import java.util.Map;

import javax.jms.Connection;
import javax.jms.JMSException;
import javax.jms.Session;

import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.jms.HornetQJMSClient;
import org.hornetq.api.jms.JMSFactoryType;
import org.hornetq.core.remoting.impl.netty.NettyConnectorFactory;
import org.hornetq.core.remoting.impl.netty.TransportConstants;
import org.hornetq.jms.client.HornetQConnectionFactory;

public class HornetQClient {

	private final HornetQConnectionFactory connectionFactory;
	
	public HornetQClient(String host, int port) {
		final Map<String, Object> connectionParams = new HashMap<String, Object>();
		
		connectionParams.put(TransportConstants.PORT_PROP_NAME, port);
		connectionParams.put(TransportConstants.HOST_PROP_NAME,	host);

		final TransportConfiguration transportConfiguration = new TransportConfiguration(NettyConnectorFactory.class.getName(), connectionParams);
		
		connectionFactory = HornetQJMSClient.createConnectionFactoryWithHA(JMSFactoryType.CF, transportConfiguration);
		
	}
	
	public Session connect(String username, String password) throws JMSException {
		Connection connection = connectionFactory.createConnection(username, password);
		
		connection.setClientID("test-client" + String.format("%1$d", System.currentTimeMillis()));
		
		connection.start();
		
		return connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
	}

}