package hornetq.client;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;
import javax.jms.TopicSubscriber;

public class HornetQConsumer {

	private static final String EXTERNAL_CLIENT = "external-client";
	
	private final Session session;
	private TopicSubscriber subscriber;

	public HornetQConsumer(Session session) {
		this.session = session;
	}
	
	public TopicSubscriber createSubscriber(String topicName) throws JMSException {
		Topic topic = session.createTopic(topicName);
		
		subscriber = session.createDurableSubscriber(topic, EXTERNAL_CLIENT);
		
		return subscriber;
	}
	
	public String receiveMessage() throws JMSException {
		Message message = subscriber.receiveNoWait();
		String text = ((TextMessage) message).getText();
		
		subscriber.close();
		session.unsubscribe(EXTERNAL_CLIENT);
		
		return text;
	}
	
	public void unsubscribe() throws JMSException {
		subscriber.close();
		session.unsubscribe(EXTERNAL_CLIENT);
	}
}