package hornetq.client;

import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;

public class HornetQSender {

	private final Session session;

	public HornetQSender(Session session) {
		this.session = session;
	}
	
	public void send(String topicName, String message) throws JMSException {
		Topic topic = session.createTopic(topicName);
		
		MessageProducer producer = session.createProducer(topic);
		
		TextMessage messageToSend = session.createTextMessage(message);

		producer.send(messageToSend);
	}
	
}