package hornetq.client;

import java.io.IOException;
import javax.jms.JMSException;
import javax.jms.Session;

public class TopicTest {
	
	private static final String HOST = "localhost";
	private static final int PORT = 5445;
	private static final String USERNAME = "admin";
	private static final String PASSWORD = "admin";
	
	public static void main(String[] args) throws IOException, JMSException {
//		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		
		System.out.println("*** Starting the connection test with topic ***");
		
//		System.out.print("Please report the topic you want to test (ex. Fares.0000): ");
//		String topicName = reader.readLine();
		
		String topicName = "testTopic";
		
		Session session = new HornetQClient(HOST, PORT).connect(USERNAME, PASSWORD);
		
		HornetQConsumer consumer = new HornetQConsumer(session);
		
		consumer.createSubscriber(topicName);
		
		HornetQSender sender = new HornetQSender(session);
		
		final String mensagem = String.format("Testing Topic'%s'", topicName);
		
		System.out.println("Sending Message: " + mensagem);
		
		sender.send(topicName, mensagem);

		System.out.println("Message sent: " + mensagem);
		

		System.out.println("Reading Message...");
		
		String mensagemRecebida = consumer.receiveMessage();
		
		System.out.println("Receiving Message: " + mensagemRecebida);
		
		System.out.println("*** Test Completed ***");
	}

}